
//  @(#)input.C 1.2 93/12/16
//
//  Various routines associated with the input popup.
//
//  Copyright (c) Rich Burridge.    All rights reserved.
//
//  Permission is given to distribute these sources, as long as the
//  copyright messages are not removed, and no monies are exchanged.
//
//  No responsibility is taken for any errors or inaccuracies inherent
//  either to the comments or the code of this program, but if
//  reported to me then an attempt will be made to fix them.

#include "mptool.h"


void Input::
do_input_apply(void)
{
  char *prologue = x.get_str_value(F_INPUT, WI_PROLOGUE) ;
 
  if (prologue && *prologue != '\0') STRCPY(opt.proname, prologue) ;
  opt.folder     = x.get_bool_value(F_INPUT, WI_INPUT_FOLDER) ;
  opt.digest     = x.get_bool_value(F_INPUT, WI_INPUT_DIGEST) ;
  opt.elm_if     = x.get_bool_value(F_INPUT, WI_INPUT_ELM) ;
  opt.print_orig = x.get_bool_value(F_INPUT, WI_INPUT_FROM) ;
  opt.content    = x.get_bool_value(F_INPUT, WI_INPUT_CONTENT) ;
  opt.modtime    = x.get_bool_value(F_INPUT, WI_INPUT_MODTIME) ;
}
 
 
void Input::
do_input_dismiss(void)
{
  XtUnmapWidget(ipopup) ;
  XtUnmanageChild(ipopup) ;
}
 
 
void Input::
do_input_reset(void)
{
  x.set_str_value(F_INPUT,  WI_PROLOGUE,      opt.proname) ;
  x.set_bool_value(F_INPUT, WI_INPUT_FOLDER,  opt.folder) ;
  x.set_bool_value(F_INPUT, WI_INPUT_DIGEST,  opt.digest) ;
  x.set_bool_value(F_INPUT, WI_INPUT_ELM,     opt.elm_if) ;
  x.set_bool_value(F_INPUT, WI_INPUT_FROM,    opt.print_orig) ;
  x.set_bool_value(F_INPUT, WI_INPUT_CONTENT, opt.content) ;
  x.set_bool_value(F_INPUT, WI_INPUT_MODTIME, opt.modtime) ;
}


void Input::
do_show_input(void)
{
  if (!ipopup)
    {
      ipopup = tu_input_frame_widget("input", base.warr[WI_MAIN_FRAME],
                                     &iwarr) ;
      x.add_delete_callback(ipopup) ;
      help.add_help(iwarr[WI_INPUT_FORM],        wi_input_frame_help) ;
      help.add_help(iwarr[WI_PROLOGUE_LABEL],    wi_prologue_help) ;
      help.add_help(iwarr[WI_PROLOGUE],          wi_prologue_help) ;
      help.add_help(iwarr[WI_INPUT_FOLDER],      wi_opt_folder_help) ;
      help.add_help(iwarr[WI_INPUT_DIGEST],      wi_opt_digest_help) ;
      help.add_help(iwarr[WI_INPUT_ELM],         wi_props_elm_help) ;
      help.add_help(iwarr[WI_INPUT_FROM],        wi_props_from_help) ;
      help.add_help(iwarr[WI_INPUT_CONTENT],     wi_props_content_help) ;
      help.add_help(iwarr[WI_INPUT_MODTIME],     wi_props_modtime_help) ;
      help.add_help(iwarr[WI_INPUT_APPLY],       wi_input_apply_help) ;
      help.add_help(iwarr[WI_INPUT_RESET],       wi_input_reset_help) ;
      help.add_help(iwarr[WI_INPUT_DISMISS],     wi_input_dismiss_help) ;
      do_input_reset() ;
    }
  x.show_popup(ipopup) ;
}


Input::
Input()
{
  iwarr = NULL ;           // No widgets defined initially.
  ipopup = NULL ;          // No input popup window initially.
}
