
//  @(#)output.C 1.3 94/02/03
//
//  Various routines associated with the output popup.
//
//  Copyright (c) Rich Burridge.    All rights reserved.
//
//  Permission is given to distribute these sources, as long as the
//  copyright messages are not removed, and no monies are exchanged.
//
//  No responsibility is taken for any errors or inaccuracies inherent
//  either to the comments or the code of this program, but if
//  reported to me then an attempt will be made to fix them.

#include "mptool.h"


void Output::
do_output_apply(void)
{
  opt.llen         = x.get_int_value(F_OUTPUT,  WI_LINE_LENGTH) ;
  opt.plen         = x.get_int_value(F_OUTPUT,  WI_PAGE_LENGTH) ;
  opt.printer_name = x.get_str_value(F_OUTPUT,  WI_PRINTER_NAME) ;
}
 
 
void Output::
do_output_dismiss(void)
{
  XtUnmapWidget(opopup) ;
  XtUnmanageChild(opopup) ;
}
 
 
void Output::
do_output_reset(void)
{
  x.set_int_value(F_OUTPUT,  WI_LINE_LENGTH,  opt.llen) ;
  x.set_int_value(F_OUTPUT,  WI_PAGE_LENGTH,  opt.plen) ;
  x.set_str_value(F_OUTPUT,  WI_PRINTER_NAME, opt.printer_name) ;
}


void Output::
do_show_output(void)
{
  if (!opopup)
    {
      opopup = tu_output_frame_widget("output", base.warr[WI_MAIN_FRAME],
                                      &owarr) ;
      x.add_delete_callback(opopup) ;
      help.add_help(owarr[WI_OUTPUT_FORM],        wi_output_frame_help) ;
      help.add_help(owarr[WI_OUTPUT_APPLY],       wi_output_apply_help) ;
      help.add_help(owarr[WI_OUTPUT_RESET],       wi_output_reset_help) ;
      help.add_help(owarr[WI_OUTPUT_DISMISS],     wi_output_dismiss_help) ;
      help.add_help(owarr[WI_LINE_LENGTH_LABEL],  wi_line_length_help) ;
      help.add_help(owarr[WI_LINE_LENGTH],        wi_line_length_help) ;
      help.add_help(owarr[WI_PAGE_LENGTH_LABEL],  wi_page_length_help) ;
      help.add_help(owarr[WI_PAGE_LENGTH],        wi_page_length_help) ;
      help.add_help(owarr[WI_PRINTER_NAME_LABEL], wi_printer_name_help) ;
      help.add_help(owarr[WI_PRINTER_NAME],       wi_printer_name_help) ;
      do_output_reset() ;
    } 
  x.show_popup(opopup) ;
}


Output::
Output()
{
  owarr = NULL ;           // No widgets defined initially.
  opopup = NULL ;          // No output popup window initially.
}

