
//  @(#)user.C 1.2 93/12/16
//
//  Various routines associated with the user name popup.
//
//  Copyright (c) Rich Burridge.    All rights reserved.
//
//  Permission is given to distribute these sources, as long as the
//  copyright messages are not removed, and no monies are exchanged.
//
//  No responsibility is taken for any errors or inaccuracies inherent
//  either to the comments or the code of this program, but if
//  reported to me then an attempt will be made to fix them.

#include "mptool.h"


void User::
do_un_apply(void)
{
  char m[MAXLINE] ;
 
  opt.aliasname = x.get_str_value(F_USER, WI_ALIASNAME) ;
 
  opt.namelength = x.get_int_value(F_USER, WI_UN_CHARS) ;
  if (opt.namelength < 1 || opt.namelength > MAXLINELENGTH)
    {
      SPRINTF(m, mptool_strs[(int) S_INVCHARS], NAMELENGTH) ;
      x.notice(uwarr[WI_USERNAME_FRAME], m) ;
      opt.namelength = NAMELENGTH ;
      x.set_int_value(F_USER, WI_UN_CHARS, opt.namelength) ;
    } 
    
  opt.namefields = x.get_int_value(F_USER, WI_UN_WORDS) ;
  if (opt.namefields < 1 || opt.namefields > MAXLINELENGTH)
    {
      SPRINTF(m, mptool_strs[(int) S_INVWORDS], NAMEFIELDS) ;
      x.notice(uwarr[WI_USERNAME_FRAME], m) ;
      opt.namefields = NAMEFIELDS ;
      x.set_int_value(F_USER, WI_UN_WORDS, opt.namefields) ;
    } 
}
 
 
void User::
do_un_dismiss(void)
{
  XtUnmapWidget(upopup) ;
  XtUnmanageChild(upopup) ;
}
 
 
void User::
do_un_reset(void)
{
  x.set_str_value(F_USER, WI_ALIASNAME, opt.aliasname) ;
  x.set_int_value(F_USER, WI_UN_CHARS,  opt.namelength) ;
  x.set_int_value(F_USER, WI_UN_WORDS,  opt.namefields) ;
}


void User::
do_show_username(void)
{
  if (!upopup)
    {
      upopup = tu_username_frame_widget("username", base.warr[WI_MAIN_FRAME],
                                         &uwarr) ;
      x.add_delete_callback(upopup) ;
      help.add_help(uwarr[WI_UN_FORM],         wi_un_form_help) ;
      help.add_help(uwarr[WI_UN_APPLY],        wi_un_apply_help) ;
      help.add_help(uwarr[WI_UN_RESET],        wi_un_reset_help) ;
      help.add_help(uwarr[WI_UN_DISMISS],      wi_un_dismiss_help) ;
      help.add_help(uwarr[WI_ALIASNAME_LABEL], wi_aliasname_help) ;
      help.add_help(uwarr[WI_ALIASNAME],       wi_aliasname_help) ;
      help.add_help(uwarr[WI_UNC_LABEL],       wi_props_passc_help) ;
      help.add_help(uwarr[WI_UN_CHARS],        wi_props_passc_help) ;
      help.add_help(uwarr[WI_UNW_LABEL],       wi_props_passw_help) ;
      help.add_help(uwarr[WI_UN_WORDS],        wi_props_passw_help) ;
      do_un_reset() ;
    } 
  x.show_popup(upopup) ;
}


User::
User()
{  
  uwarr = NULL ;           // No widgets defined initially.
  upopup = NULL ;          // No user name popup window initially.
}
